(*
$Id: memoire.ml,v 1.1.1.1 1998/06/23 22:35:08 monniaux Exp $
*)


open Typeintermed;;

type linkage = V of string * int | P of string | EP of string | A of string * int | DA of string * int | IV of string * int * result_type;;


let rec long = function [] -> 0
                      | _::l -> 1+long l;;



module OrderedType = struct
   type t = int
   let compare a b = a-b
end;;


module Table = Map.Make (OrderedType);;

let tds = ref Table.empty;;


let max a b = if a > b then a else b;;

let m = function (a, b) -> function (c, d) -> ([], max b d);;

let list_proc = ref [];;


let name_proc = ref "main__";;


let rec declar_param n = function
  | [] -> ()
  | (x, Integer)::l -> tds := Table.add x (A (!name_proc, n)) !tds ; declar_param (n+4) l
  | (x, RefType (_))::l -> tds := Table.add x (A (!name_proc, n)) !tds ; declar_param (n+4) l
  | (x, _)::l -> tds := Table.add x (DA (!name_proc, n)) !tds ; declar_param (n+4) l;;

let trad dec = function
       | V (ss, d) when ss = (!name_proc) -> (PAdd (FramePtr, IConst (-8-d)), dec)
       | V (ss, d) -> (PAdd (P_peek (AsmLabel ("frame__"^ss)), IConst (-8-d)), dec)
       | IV (ss, d, RefType (_)) when ss = (!name_proc) -> 
            (P_peek (PAdd (FramePtr, IConst (-8-d))), dec)
       | IV (ss, d, RefType (_)) -> 
            (P_peek (PAdd (P_peek (AsmLabel ("frame__"^ss)), IConst (-8-d))), dec)
       | IV (ss, d, Integer) when ss = (!name_proc) -> 
            failwith "j'en ai marre ! 1"
       | IV (ss, d, Integer) -> 
            failwith "j'en ai marre ! 2"
       | IV (ss, d, Float) when ss = (!name_proc) -> 
            failwith "j'en ai marre ! 3"
       | IV (ss, d, Float) -> 
            failwith "j'en ai marre ! 4"
       | IV (ss, d, Boolean) when ss = (!name_proc) -> 
            failwith "j'en ai marre ! 5"
       | IV (ss, d, Boolean) -> 
            failwith "j'en ai marre ! 6"
       | IV (ss, d, RefArrayType (_)) when ss = (!name_proc) -> 
            (P_peek (PAdd (FramePtr, IConst (-8-d))), dec)
       | IV (ss, d, RefArrayType (_)) -> 
            (P_peek (PAdd (P_peek (AsmLabel ("frame__"^ss)), IConst (-8-d))), dec)
       | IV (_, _, _) -> failwith "je programme comme un pied 1"
       | P (id) -> (AsmLabel ("proc__"^id), dec)
       | EP (id) -> (AsmLabel (id), dec)
       | A (ss, d) when ss = (!name_proc) -> (PAdd (FramePtr, IConst (68+d)), dec)
       | A (ss, d) -> (PAdd (P_peek (AsmLabel ("frame__"^ss)), IConst (68+d)), dec)
       | DA (ss, d) when ss = (!name_proc) -> (P_peek (PAdd (FramePtr, IConst (68+d))), dec)
       | DA (ss, d) -> (P_peek (PAdd (P_peek(AsmLabel ("frame__"^ss)), IConst (68+d))), dec);;

let itrad dec = function
       | V (ss, d) when ss = (!name_proc) -> 
            failwith "j'en ai marre ! 7"
       | V (ss, d) -> 
            failwith "j'en ai marre ! 8"
       | IV (ss, d, RefType (_)) when ss = (!name_proc) -> 
            failwith "j'en ai marre ! 9"
       | IV (ss, d, RefType (_)) -> 
            failwith "j'en ai marre ! 10"
       | IV (ss, d, Integer) when ss = (!name_proc) -> 
            (I_peek (PAdd (FramePtr, IConst (-8-d))), dec)
       | IV (ss, d, Integer) -> 
            (I_peek (PAdd (P_peek (AsmLabel ("frame__"^ss)), IConst (-8-d))), dec)
       | IV (ss, d, Float) when ss = (!name_proc) -> 
             failwith "j'en ai marre ! 11"
       | IV (ss, d, Float) -> 
             failwith "j'en ai marre ! 12"
       | IV (ss, d, Boolean) when ss = (!name_proc) -> 
            failwith "j'en ai marre ! 13"
       | IV (ss, d, Boolean) -> 
            failwith "j'en ai marre ! 14"
       | IV (_, _, _) -> failwith "je programme comme un pied 2"
       | P (id) -> 
            failwith "j'en ai marre ! 15"
       | EP (id) -> 
            failwith "j'en ai marre ! 16"
       | A (ss, d) when ss = (!name_proc) -> 
            failwith "j'en ai marre ! 17"
       | A (ss, d) -> 
            failwith "j'en ai marre ! 18"
       | DA (ss, d) when ss = (!name_proc) -> 
            failwith "j'en ai marre ! 19"
       | DA (ss, d) -> 
            failwith "j'en ai marre ! 20";;

let ftrad dec = function
       | V (ss, d) when ss = (!name_proc) -> 
            failwith "j'en ai marre ! 21"
       | V (ss, d) -> 
            failwith "j'en ai marre ! 22"
       | IV (ss, d, RefType (_)) when ss = (!name_proc) -> 
            failwith "j'en ai marre ! 23"
       | IV (ss, d, RefType (_)) -> 
            failwith "j'en ai marre ! 24"
       | IV (ss, d, Integer) when ss = (!name_proc) -> 
             failwith "j'en ai marre ! 25"
       | IV (ss, d, Integer) -> 
             failwith "j'en ai marre ! 26"
       | IV (ss, d, Float) when ss = (!name_proc) -> 
            (F_peek (PAdd (FramePtr, IConst (-8-d))), dec)
       | IV (ss, d, Float) -> 
            (F_peek (PAdd (P_peek (AsmLabel ("frame__"^ss)), IConst (-8-d))), dec)
       | IV (ss, d, Boolean) when ss = (!name_proc) -> 
            failwith "j'en ai marre ! 27"
       | IV (ss, d, Boolean) -> 
            failwith "j'en ai marre ! 28"
       | IV (_, _, _) -> failwith "je programme comme un pied 3"
       | P (id) -> 
            failwith "j'en ai marre ! 29"
       | EP (id) -> 
            failwith "j'en ai marre ! 30"
       | A (ss, d) when ss = (!name_proc) -> 
            failwith "j'en ai marre ! 31"
       | A (ss, d) -> 
            failwith "j'en ai marre ! 32"
       | DA (ss, d) when ss = (!name_proc) -> 
            failwith "j'en ai marre ! 33"
       | DA (ss, d) -> 
            failwith "j'en ai marre ! 34";;

let btrad dec = function
       | V (ss, d) when ss = (!name_proc) -> 
            failwith "j'en ai marre ! 35"
       | V (ss, d) -> 
            failwith "j'en ai marre ! 36"
       | IV (ss, d, RefType (_)) when ss = (!name_proc) -> 
            failwith "j'en ai marre ! 37"
       | IV (ss, d, RefType (_)) -> 
            failwith "j'en ai marre ! 38"
       | IV (ss, d, Integer) when ss = (!name_proc) -> 
            failwith "j'en ai marre ! 39"
       | IV (ss, d, Integer) -> 
            failwith "j'en ai marre ! 40"
       | IV (ss, d, Float) when ss = (!name_proc) -> 
             failwith "j'en ai marre ! 41"
       | IV (ss, d, Float) -> 
             failwith "j'en ai marre ! 42"
       | IV (ss, d, Boolean) when ss = (!name_proc) -> 
            (B_peek (PAdd (FramePtr, IConst (-8-d))), dec)
       | IV (ss, d, Boolean) -> 
            (B_peek (PAdd (P_peek (AsmLabel ("frame__"^ss)), IConst (-8-d))), dec)
       | IV (_, _, _) -> failwith "je programme comme un pied 4"
       | P (id) -> 
            failwith "j'en ai marre ! 43"
       | EP (id) -> 
            failwith "j'en ai marre ! 44"
       | A (ss, d) when ss = (!name_proc) -> 
            failwith "j'en ai marre ! 45"
       | A (ss, d) -> 
            failwith "j'en ai marre ! 46"
       | DA (ss, d) when ss = (!name_proc) -> 
            failwith "j'en ai marre ! 47"
       | DA (ss, d) -> 
            failwith "j'en ai marre ! 48";;


let size = function 
      | Integer ->  4
      | Boolean -> 4
      | Float -> 8
      | RefType (_) -> 4
      | RefArrayType (_, d) -> 4
      | _ -> failwith "err size";;

let first (a, b) = a;;

let rec gen_cde = function (dl, dec) -> function size -> function
   | [] -> failwith "chuis vraiment nul !!!"
   | [(e1, e2)] -> let ((e1, b), (e2, d)) = (iexpr_conv (e1, (dl, dec)), iexpr_conv (e2, (dl, dec))) in 
     (I_peek (IAssignment (PAdd (FramePtr, IConst (-8-dec)), IMul (IConst (size), ISub (IAdd ( e2, IConst (1)), 
     I_peek (IAssignment (PAdd (FramePtr, IConst (-12-dec)), e1))))))), (m b d)

   | (e1, e2)::l -> let ((e1, b), (e2, d)) = (iexpr_conv (e1, (dl, dec)), iexpr_conv (e2, (dl, dec))) in 
         let (cou, moi) = gen_cde (dl, dec+8) size l in 
         (I_peek (IAssignment (PAdd (FramePtr, IConst (-8-dec)), IMul (ISub (IAdd (e2, IConst (1)), I_peek (
         IAssignment (PAdd (FramePtr, IConst (-12-dec)), e1))), cou)))), (m moi (m b d))


and gen_code = function (dl, dec) -> function size -> function
   | [] -> failwith "chuis nul !"
   | [(e1, e2)] -> let ((e1, b), (e2, d)) = (iexpr_conv (e1, (dl, dec)), iexpr_conv (e2, (dl, dec))) in 
         (V_from_p (PAssignment (PAdd (FramePtr, IConst (-8-dec)), Alloca (IAdd (IConst (4), I_peek (IAssignment 
         (PAdd (FramePtr, IConst (-12-dec)), IMul (ISub (IAdd (e2, IConst (1)), I_peek (
          IAssignment (PAdd (FramePtr, IConst (-16-dec)), e1))), IConst (size))))))))), (m b d)

   | (e1, e2)::l -> let ((e1, b), (e2, d)) = (iexpr_conv (e1, (dl, dec)), iexpr_conv (e2, (dl, dec))) in 
         let (cou, moi) = gen_cde (dl, dec+12) size l in 
         (V_from_p (PAssignment (PAdd (FramePtr, IConst (-8-dec)), Alloca (I_peek (IAssignment 
         (PAdd (FramePtr, IConst (-12-dec)), IMul (ISub (IAdd (e2, IConst (1)), I_peek (
         IAssignment (PAdd (FramePtr, IConst (-16-dec)), e1))), cou))))))), (m moi (m b d))
                                     


and arg_conv = function (l, d) -> match l with 
   | [] -> ([], d)
   | x::l -> let (a, b) = expr_conv (x, d) in let (c, e) = arg_conv (l, b) in (a::c, e)


and iexpr_conv = function (a, dec) -> match a with
   | IAdd (e1, e2) -> (match (iexpr_conv (e1, dec), iexpr_conv (e2, dec)) with 
         | ((IConst (i1), s), (IConst (i2), t)) -> (IConst (i1+ i2), m s t)
         | ((IAdd (IConst(i1), e1), s), (IAdd(IConst(i2), e2), t)) -> 
                                     (IAdd (IConst (i1+i2), IAdd (e1, e2)), m s t)
         | ((ISub (IConst(i1), e1), s), (IAdd (IConst (i2), e2), t)) -> 
                                     (IAdd (IConst (i1+i2), ISub (e2, e1)), m s t)
         | ((IAdd (IConst (i1), e1), s), (ISub (IConst (i2), e2), t)) -> 
                                     (IAdd (IConst (i1+i2), ISub (e1, e2)), m s t)
         | ((ISub (IConst (i1), e1), s), (ISub (IConst (i2), e2), t)) -> 
                                     (ISub (IConst (i1+i2), IAdd (e1, e2)), m s t)
         | ((IConst (i1), s), (e2, t)) -> (IAdd (IConst (i1), e2), m s t)
         | ((IAdd (IConst (i1), e1), s), (e2, t)) -> (IAdd (IConst (i1), IAdd (e1, e2)), m s t)
         | ((ISub (IConst (i1), e1), s), (e2, t)) -> (IAdd (IConst (i1), ISub (e2, e1)), m s t)
         | ((e1, s), (IConst (i2), t)) -> (IAdd (IConst (i2), e1), m s t)
         | ((e1, s), (IAdd (IConst (i2), e2), t)) -> (IAdd (IConst (i2), IAdd (e1, e2)), m s t)
         | ((e1, s), (ISub (IConst (i2), e2), t)) -> (IAdd (IConst (i2), ISub (e1, e2)), m s t)
         | ((e1, s), (e2, t)) -> (IAdd (e1, e2), m s t))

    | ISub (e1, e2) -> (match (iexpr_conv (e1, dec), iexpr_conv (e2, dec)) with 
         | ((IConst (i1), s), (IConst (i2), t)) -> (IConst (i1- i2), m s t)
         | ((IAdd (IConst (i1), e1), s), (IAdd (IConst (i2), e2), t)) -> 
                                     (IAdd (IConst (i1- i2), ISub (e1, e2)), m s t)
         | ((ISub (IConst (i1), e1), s), (IAdd (IConst (i2), e2), t)) -> 
                                     (ISub (IConst (i1- i2), IAdd (e1, e2)), m s t)
         | ((IAdd (IConst (i1), e1), s), (ISub (IConst (i2), e2), t)) -> 
                                     (IAdd (IConst (i1- i2), IAdd (e1, e2)), m s t)
         | ((ISub (IConst (i1), e1), s), (ISub (IConst (i2), e2), t)) -> 
                                     (IAdd (IConst (i1- i2), ISub (e2, e1)), m s t)
         | ((IConst (i1), s), (e2, t)) -> (ISub (IConst (i1), e2), m s t)
         | ((IAdd (IConst (i1), e1), s), (e2, t)) -> (IAdd (IConst (i1), ISub (e1, e2)), m s t)
         | ((ISub (IConst (i1), e1), s), (e2, t)) -> (ISub (IConst (i1), IAdd (e1, e2)), m s t)
         | ((e1, s), (IConst (i2), t)) -> (IAdd (IConst (-i2), e1), m s t)
         | ((e1, s), (IAdd (IConst (i2), e2), t)) -> (IAdd (IConst (-i2), ISub (e1, e2)), m s t)
         | ((e1, s), (ISub (IConst (i2), e2), t)) -> (IAdd (IConst (-i2), IAdd (e1, e2)), m s t)
         | ((e1, s), (e2, t)) -> (ISub (e1, e2), m s t))

    | IMul (e1, e2) -> (match (iexpr_conv (e1, dec), iexpr_conv (e2, dec)) with 
         | ((IConst (i1), s), (IConst (i2), t)) -> (IConst (i1* i2), m s t)
         | ((IMul (IConst (i1), e1), s), (IMul (IConst (i2), e2), t)) -> 
                                     (IMul (IConst (i1* i2), IMul (e1, e2)), m s t)
         | ((IConst (i1), s), (e2, t)) -> (IMul (IConst (i1), e2), m s t)
         | ((e1, s), (IConst (i2), t)) -> (IMul (IConst (i2), e1), m s t)
         | ((e1, s), (e2, t)) -> (IMul (e1, e2), m s t))

    | IDiv (e1, e2) -> (match (iexpr_conv (e1, dec), iexpr_conv (e2, dec)) with 
         | ((IConst (i1), s), (IConst (i2), t)) -> (IConst (i1 / i2), m s t)
         | ((e1, s), (e2, t)) -> (IDiv (e1, e2), m s t))

    | IMod (e1, e2) -> (match (iexpr_conv (e1, dec), iexpr_conv (e2, dec)) with 
         | ((IConst (i1), s), (IConst (i2), t)) -> (IConst (i1 mod i2), m s t)
         | ((e1, s), (e2, t)) -> (IMod (e1, e2), m s t))

    | INeg (e) -> (match (iexpr_conv (e, dec)) with 
         | (IConst (i), s) -> (IConst (-i), s)
         | (e, s) -> (INeg (e), s))

    | IConst (i) -> (IConst (i), dec)
    | I_peek (e) -> let (u, t) = pexpr_conv (e, dec) in (I_peek (u), t) 

    | Iprocedure (p, l) -> (match (pexpr_conv (p, dec), arg_conv (l, dec)) with 
         | ((pp, s), (ll, t)) -> (Iprocedure (pp, ll), m s t)) 

    | I_ITE (b, i1, i2) -> (match (bexpr_conv (b, dec), iexpr_conv (i1, dec), iexpr_conv (i2, dec)) with 
         | ((bb, r), (e1, s), (e2, t)) -> (I_ITE (bb, e1, e2), m r (m s t)))

    | Iseq (v, i) -> (match (vexpr_conv (v, dec), iexpr_conv (i, dec)) with 
         | ((e1, s), (e2, t)) -> (Iseq (e1, e2), m s t))

    | IBlock (l, i) -> let (e1, e3, s, u) = declaration (l, dec) in let (e2, t) = iexpr_conv (i, s) in 
         (Iinvseq (Iseq (e1, e2), e3), m t u)

    | Iinvseq (_) -> failwith "impossible"

    | IVar (i) -> itrad dec 
           (try (Table.find i !tds) with Not_found -> print_int (i); failwith "not_found")


  
and fexpr_conv  = function (a, dec) -> match a with
   | FAdd (e1, e2) -> (match (fexpr_conv (e1, dec), fexpr_conv (e2, dec)) with 
         | ((FConst (i1), s), (FConst (i2), t)) -> (FConst (i1 +. i2), m s t)
         | ((FAdd (FConst(i1), e1), s), (FAdd(FConst(i2), e2), t)) -> 
                                     (FAdd (FConst (i1 +. i2), FAdd (e1, e2)), m s t)
         | ((FSub (FConst(i1), e1), s), (FAdd (FConst (i2), e2), t)) -> 
                                     (FAdd (FConst (i1 +. i2), FSub (e2, e1)), m s t)
         | ((FAdd (FConst (i1), e1), s), (FSub (FConst (i2), e2), t)) -> 
                                     (FAdd (FConst (i1 +. i2), FSub (e1, e2)), m s t)
         | ((FSub (FConst (i1), e1), s), (FSub (FConst (i2), e2), t)) -> 
                                     (FSub (FConst (i1 +. i2), FAdd (e1, e2)), m s t)
         | ((FConst (i1), s), (e2, t)) -> (FAdd (FConst (i1), e2), m s t)
         | ((FAdd (FConst (i1), e1), s), (e2, t)) -> (FAdd (FConst (i1), FAdd (e1, e2)), m s t)
         | ((FSub (FConst (i1), e1), s), (e2, t)) -> (FAdd (FConst (i1), FSub (e2, e1)), m s t)
         | ((e1, s), (FConst (i2), t)) -> (FAdd (FConst (i2), e1), m s t)
         | ((e1, s), (FAdd (FConst (i2), e2), t)) -> (FAdd (FConst (i2), FAdd (e1, e2)), m s t)
         | ((e1, s), (FSub (FConst (i2), e2), t)) -> (FAdd (FConst (i2), FSub (e1, e2)), m s t)
         | ((e1, s), (e2, t)) -> (FAdd (e1, e2), m s t))

    | FSub (e1, e2) -> (match (fexpr_conv (e1, dec), fexpr_conv (e2, dec)) with 
         | ((FConst (i1), s), (FConst (i2), t)) -> (FConst (i1 -. i2), m s t)
         | ((FAdd (FConst (i1), e1), s), (FAdd (FConst (i2), e2), t)) -> 
                                     (FAdd (FConst (i1 -. i2), FSub (e1, e2)), m s t)
         | ((FSub (FConst (i1), e1), s), (FAdd (FConst (i2), e2), t)) -> 
                                     (FSub (FConst (i1 -. i2), FAdd (e1, e2)), m s t)
         | ((FAdd (FConst (i1), e1), s), (FSub (FConst (i2), e2), t)) -> 
                                     (FAdd (FConst (i1 -. i2), FAdd (e1, e2)), m s t)
         | ((FSub (FConst (i1), e1), s), (FSub (FConst (i2), e2), t)) -> 
                                     (FAdd (FConst (i1 -. i2), FSub (e2, e1)), m s t)
         | ((FConst (i1), s), (e2, t)) -> (FSub (FConst (i1), e2), m s t)
         | ((FAdd (FConst (i1), e1), s), (e2, t)) -> (FAdd (FConst (i1), FSub (e1, e2)), m s t)
         | ((FSub (FConst (i1), e1), s), (e2, t)) -> (FSub (FConst (i1), FAdd (e1, e2)), m s t)
         | ((e1, s), (FConst (i2), t)) -> (FAdd (FConst (-.i2), e1), m s t)
         | ((e1, s), (FAdd (FConst (i2), e2), t)) -> (FAdd (FConst (-.i2), FSub (e1, e2)), m s t)
         | ((e1, s), (FSub (FConst (i2), e2), t)) -> (FAdd (FConst (-.i2), FAdd (e1, e2)), m s t)
         | ((e1, s), (e2, t)) -> (FSub (e1, e2), m s t))

    | FMul (e1, e2) -> (match (fexpr_conv (e1, dec), fexpr_conv (e2, dec)) with 
         | ((FConst (i1), s), (FConst (i2), t)) -> (FConst (i1 *. i2), m s t)
         | ((FMul (FConst (i1), e1), s), (FMul (FConst (i2), e2), t)) -> 
                                     (FMul (FConst (i1 *. i2), FMul (e1, e2)), m s t)
         | ((FConst (i1), s), (e2, t)) -> (FMul (FConst (i1), e2), m s t)
         | ((e1, s), (FConst (i2), t)) -> (FMul (FConst (i2), e1), m s t)
         | ((e1, s), (e2, t)) -> (FMul (e1, e2), m s t))

    | FDiv (e1, e2) -> (match (fexpr_conv (e1, dec), fexpr_conv (e2, dec)) with 
         | ((FConst (i1), s), (FConst (i2), t)) -> (FConst (i1 /. i2), m s t)
         | ((e1, s), (e2, t)) -> (FDiv (e1, e2), m s t))

    | FNeg (e) -> (match (fexpr_conv (e, dec)) with 
         | (FConst (i), s) -> (FConst (-.i), s)
         | (e, s) -> (FNeg (e), s))

    | F_from_i (e) -> (match (iexpr_conv (e, dec)) with 
         | (IConst (i), s) -> (FConst (float i), s)
         | (e, s) -> (F_from_i (e), s))

    | FConst (i) -> (FConst (i), dec)
    | F_peek (e) -> let (u, t) = pexpr_conv (e, dec) in (F_peek (u), t) 

    | Fprocedure (p, l) -> (match (pexpr_conv (p, dec), arg_conv (l, dec)) with 
         | ((pp, s), (ll, t)) -> (Fprocedure (pp, ll), m s t)) 

    | F_ITE (b, i1, i2) -> (match (bexpr_conv (b, dec), fexpr_conv (i1, dec), fexpr_conv (i2, dec)) with 
         | ((bb, r), (e1, s), (e2, t)) -> (F_ITE (bb, e1, e2), m r (m s t)))

    | Fseq (v, i) -> (match (vexpr_conv (v, dec), fexpr_conv (i, dec)) with 
         | ((e1, s), (e2, t)) -> (Fseq (e1, e2), m s t))

    | FBlock (l, i) -> let (e1, e3, s, u) = declaration (l, dec) in let (e2, t) = fexpr_conv (i, s) in 
         (Finvseq (Fseq (e1, e2), e3), m t u)

    | Finvseq (_) -> failwith "impossible"

    | FVar (i) -> ftrad dec 
           (try (Table.find i !tds) with Not_found -> print_int (i); failwith "not_found")



and bexpr_conv = function (a, dec) -> match a with
    | Bprocedure (p, l) -> (match (pexpr_conv (p, dec), arg_conv (l, dec)) with 
         | ((pp, s), (ll, t)) -> (Bprocedure (pp, ll), m s t)) 

    | BBlock (l, i) -> let (e1, e3, s, u) = declaration (l, dec) in let (e2, t) = bexpr_conv (i, s) in 
         (Binvseq (Bseq (e1, e2), e3), m t u)

    | BNot (e) -> (match (bexpr_conv (e, dec)) with 
         | (True, s) -> (False, s)
         | (False, s) -> (True, s)
         | (e, s) -> (BNot (e), s))

    | B_peek (e) -> let (u, t) = pexpr_conv (e, dec) in (B_peek (u), t) 

    | Bseq (v, i) -> (match (vexpr_conv (v, dec), bexpr_conv (i, dec)) with 
         | ((e1, s), (e2, t)) -> (Bseq (e1, e2), m s t))

    | B_ITE (b, i1, i2) -> (match (bexpr_conv (b, dec), bexpr_conv (i1, dec), bexpr_conv (i2, dec)) with 
         | ((bb, r), (e1, s), (e2, t)) -> (B_ITE (bb, e1, e2), m (m s t) r))

    | True -> (True, dec)

    | False -> (False, dec)

    | IInf (e1, e2) -> (match (iexpr_conv (e1, dec), iexpr_conv (e2, dec)) with 
         | ((IConst (i1), s), (IConst (i2), t)) -> if (i1 < i2) then (True, dec) else (False, dec)
         | ((e1, s), (e2, t)) -> (IInf (e1, e2), m s t))

    | ISup (e1, e2) -> (match (iexpr_conv (e1, dec), iexpr_conv (e2, dec)) with 
         | ((IConst (i1), s), (IConst (i2), t)) -> if (i1 > i2) then (True, dec) else (False, dec)
         | ((e1, s), (e2, t)) -> (ISup (e1, e2), m s t))

    | FInf (e1, e2) -> (match (fexpr_conv (e1, dec), fexpr_conv (e2, dec)) with 
         | ((FConst (i1), s), (FConst (i2), t)) -> if (i1 < i2) then (True, dec) else (False, dec)
         | ((e1, s), (e2, t)) -> (FInf (e1, e2), m s t))

    | FSup (e1, e2) -> (match (fexpr_conv (e1, dec), fexpr_conv (e2, dec)) with 
         | ((FConst (i1), s), (FConst (i2), t)) -> if (i1 > i2) then (True, dec) else (False, dec)
         | ((e1, s), (e2, t)) -> (FSup (e1, e2), m s t))

    | IEgal (e1, e2) -> (match (iexpr_conv (e1, dec), iexpr_conv (e2, dec)) with 
         | ((IConst (i1), s), (IConst (i2), t)) -> if (i1 = i2) then (True, dec) else (False, dec)
         | ((e1, s), (e2, t)) -> (IEgal (e1, e2), m s t))

    | FEgal (e1, e2) -> (match (fexpr_conv (e1, dec), fexpr_conv (e2, dec)) with 
         | ((FConst (i1), s), (FConst (i2), t)) -> if (i1 = i2) then (True, dec) else (False, dec)
         | ((e1, s), (e2, t)) -> (FEgal (e1, e2), m s t))

    | BEgal (e1, e2) -> (match (bexpr_conv (e1, dec), bexpr_conv (e2, dec)) with 
         | ((e1, s), (e2, t)) -> (BEgal (e1, e2), m s t))

    | PEgal (e1, e2) -> (match (pexpr_conv (e1, dec), pexpr_conv (e2, dec)) with 
         | ((e1, s), (e2, t)) -> (PEgal (e1, e2), m s t))

    | BAnd (e1, e2) -> (match (bexpr_conv (e1, dec), bexpr_conv (e2, dec)) with 
         | ((e1, s), (e2, t)) -> (BAnd (e1, e2), m s t))

    | BOr (e1, e2) -> (match (bexpr_conv (e1, dec), bexpr_conv (e2, dec)) with 
         | ((e1, s), (e2, t)) -> (BOr (e1, e2), m s t))

    | Binvseq (_) -> failwith "impossible"

    | BVar (i) -> btrad dec 
           (try (Table.find i !tds) with Not_found -> print_int (i); failwith "not_found")



and vexpr_conv = function (a, dec) -> match a with 
    | Vseq (v, i) -> (match (vexpr_conv (v, dec), vexpr_conv (i, dec)) with 
         | ((e1, s), (e2, t)) -> (Vseq (e1, e2), m s t))

    | VBlock (l, i) -> let (e1, e3, s, u) = declaration (l, dec) in let (e2, t) = vexpr_conv (i, s) in 
         (Vseq (Vseq (e1, e2), e3), m t u)

    | V_ITE (b, i1, i2) -> (match (bexpr_conv (b, dec), vexpr_conv (i1, dec), vexpr_conv (i2, dec)) with 
         | ((bb, r), (e1, s), (e2, t)) -> (V_ITE (bb, e1, e2), m (m s t) r))

    | Vprocedure (p, l) -> (match (pexpr_conv (p, dec), arg_conv (l, dec)) with 
         | ((pp, s), (ll, t)) -> (Vprocedure (pp, ll), m s t)) 

    | For (v, i1, i2, e) ->  
       (match dec with
      | ([], dec) -> (tds := Table.add v (V (!name_proc, (dec+4))) !tds ;
       let ((e1, s), (e2, t), (e, u)) = 
           (iexpr_conv (i1, ([dec+8], dec+8)), iexpr_conv (i2, ([dec+8], dec+8)), vexpr_conv (e, ([dec+8], dec+8))) in 
           (For (v, e1, e2, e), (m (m s t) u)))
      | (x::l, dec) -> (tds := Table.add v (V (!name_proc, x)) !tds ;
       let ((e1, s), (e2, t), (e, u)) = 
           (iexpr_conv (i1, (l, dec)), iexpr_conv (i2, (l, dec)), vexpr_conv (e, (l, dec))) in 
           (For (v, e1, e2, e), (m (m s t) u))))

    | While (b, e) -> (match (bexpr_conv (b, dec), vexpr_conv (e, dec)) with 
         | ((e1, s), (e2, t)) -> (While (e1, e2), m s t))

    | V_IT (b, e) -> (match (bexpr_conv (b, dec), vexpr_conv (e, dec)) with 
         | ((e1, s), (e2, t)) -> (V_IT (e1, e2), m s t))

    | CopyBlock (p1, p2, i) -> (match (pexpr_conv (p1, dec), pexpr_conv (p2, dec), iexpr_conv (i, dec)) with 
         | ((e1, s), (e2, t), (e3, u)) -> (CopyBlock (e1, e2, e3), m u (m s t)))

    | FCopyBlock (p1, p2, i) -> (match (pexpr_conv (p1, dec), pexpr_conv (p2, dec), iexpr_conv (i, dec)) with 
         | ((e1, s), (e2, t), (e3, u)) -> (FCopyBlock (e1, e2, e3), m u (m s t)))

    | NNop -> (NNop, dec) 

    | Erreur -> (Erreur, dec) 

    | Errorexpr -> raise Exit

    | V_from_i (e) -> (match (iexpr_conv (e, dec)) with 
         | (IConst (i), s) -> (NNop, dec)
         | (e, s) -> (V_from_i (e), s))

    | V_from_f (e) -> (match (fexpr_conv (e, dec)) with 
         | (FConst (i), s) -> (NNop, dec)
         | (e, s) -> (V_from_f (e), s))

    | V_from_b (e) -> (match (bexpr_conv (e, dec)) with 
         | (e, s) -> (V_from_b (e), s))

    | V_from_p (e) -> (match (pexpr_conv (e, dec)) with 
         | (e, s) -> (V_from_p (e), s))

    | Free -> (Free, dec)


and pexpr_conv = function (a, dec) -> match a with

    | Pinvseq (_) -> failwith "impossible"

    | Pprocedure (p, l) -> (match (pexpr_conv (p, dec), arg_conv (l, dec)) with 
         | ((pp, s), (ll, t)) -> (Pprocedure (pp, ll), m s t)) 

    | P_ITE (b, i1, i2) -> (match (bexpr_conv (b, dec), pexpr_conv (i1, dec), pexpr_conv (i2, dec)) with 
         | ((bb, r), (e1, s), (e2, t)) -> (P_ITE (bb, e1, e2), m r (m s t)))

    | Pseq (v, i) -> (match (vexpr_conv (v, dec), pexpr_conv (i, dec)) with 
         | ((e1, s), (e2, t)) -> (Pseq (e1, e2), m s t))

    | PBlock (l, i) -> let (e1, e3, s, u) = declaration (l, dec) in let (e2, t) = pexpr_conv (i, s) in 
         (Pinvseq (Pseq (e1, e2), e3), m t u)

    | P_peek (e) -> let (u, t) = pexpr_conv (e, dec) in (P_peek (u), t)

    | Var (i) -> trad dec 
           (try (Table.find i !tds) with Not_found -> print_int (i); failwith "not_found")

    | Nil -> (Nil, dec)

    | IAssignment (p, i) -> (match (pexpr_conv (p, dec), iexpr_conv (i, dec)) with 
         | ((e1, s), (e2, t)) -> (IAssignment (e1, e2), m s t))

    | FAssignment (p, i) -> (match (pexpr_conv (p, dec), fexpr_conv (i, dec)) with 
         | ((e1, s), (e2, t)) -> (FAssignment (e1, e2), m s t))

    | BAssignment (p, i) -> (match (pexpr_conv (p, dec), bexpr_conv (i, dec)) with 
         | ((e1, s), (e2, t)) -> (BAssignment (e1, e2), m s t))

    | PAssignment (p, i) -> (match (pexpr_conv (p, dec), pexpr_conv (i, dec)) with 
         | ((e1, s), (e2, t)) -> (PAssignment (e1, e2), m s t))

    | PAdd (p, i) -> (match (pexpr_conv (p, dec), iexpr_conv (i, dec)) with 
         | ((PAdd (pp, IConst (c)), s), (IConst (d), t)) -> (PAdd (pp, IConst (c+d)), m s t)
         | ((PAdd (pp, IConst (c)), s), (e2, t)) -> (PAdd (PAdd (pp, e2), IConst (c)), m s t)
         | ((e1, s), (e2, t)) -> (PAdd (e1, e2), m s t))

    | _ -> failwith "coucou"


and expr_conv = function (x, y) -> match x with 
    | Iexpr (e) -> let (a, b) = iexpr_conv (e, y) in (Iexpr (a), b)
    | Bexpr (e) -> let (a, b) = bexpr_conv (e, y) in (Bexpr (a), b)
    | Fexpr (e) -> let (a, b) = fexpr_conv (e, y) in (Fexpr (a), b)
    | Pexpr (_, e, t) -> let (a, b) = pexpr_conv (e, y) in (Pexpr (0, a, t), b)
    | Vexpr (e) -> let (a, b) = vexpr_conv (e, y) in (Vexpr (a), b)


and declaration = function (a, (dl, dec)) -> match a with

  | [] -> (NNop, NNop, (dl, dec), (dl, dec))

  | (VariableDecl (id, nb, t))::l -> (match (size t) with
        | 4 -> (match dl with
            | [] -> (tds := Table.add nb (V (!name_proc, (dec+4))) !tds ; let ut = dec + 8 in 
              declaration (l, (ut::dl, dec+8)) )
            | xdl::dl -> (tds := Table.add nb (V (!name_proc, xdl)) !tds ; 
              declaration (l, (dl, dec)) ))
        | 8 -> (tds := Table.add nb (V (!name_proc, (dec+8))) !tds ;
         declaration (l, (dl, dec+8)) )
        | _ -> failwith "quel idiot je suis")

  | (ArrayDecl { array_id = id; array_nb = nb ; array_bounds = l ; array_type = t})::lll -> 
         let (d, size) = (long l, size t) in (tds := Table.add nb (V (!name_proc, dec+4)) !tds ;
         let (cde, uu) = gen_code (dl, dec+4) size l in
         let (ll, mm, s, u) = declaration (lll, ((dec+8*(d+1))::dl, dec+8*(d+1))) in 
              (Vseq (cde, ll), Vseq (mm, Free), s, m u uu))


  | (IdentityDecl (id, nb, e, t))::l -> (match size t with
        | 8 -> (tds := Table.add nb (IV (!name_proc, dec+8, t)) !tds ; 
                tds := Table.add (nb+1) (V (!name_proc, dec+8)) !tds ;
                   let (ll, mm, s, u) = declaration (l, (dl, dec+8)) in 
                   (match (expr_conv (e, (dl, dec))) with 
                | (Pexpr (_, e, tpe), t) -> (Vseq (V_from_p (e), ll), mm, s, m t u)
                | _ -> failwith "declaration"))
        | 4 -> (match dl with
            | [] -> (tds := Table.add nb (IV (!name_proc, dec+4, t)) !tds ; 
                    tds := Table.add (nb+1) (V (!name_proc, dec+4)) !tds ; let ut = dec + 8 in 
                   let (ll, mm, s, u) = declaration (l, (ut::dl, dec+8)) in 
                   (match (expr_conv (e, (dl, dec))) with 
                | (Pexpr (_, e, tpe), t) -> (Vseq (V_from_p (e), ll), mm, s, m t u)
                | _ -> failwith "declaration"))
            | xdl::dl -> (tds := Table.add nb (IV (!name_proc, xdl, t)) !tds ; 
                          tds := Table.add (nb+1) (V (!name_proc, xdl)) !tds ;
                   let (ll, mm, s, u) = declaration (l, (dl, dec)) in 
                   (match (expr_conv (e, (dl, dec))) with 
                | (Pexpr (_, e, tpe), t) -> (Vseq (V_from_p (e), ll), mm, s, m t u)
                | _ -> failwith "declaration")))
        | _ -> failwith "quel imbecile je fait... ")

  | (IdentityDeclex (id, nb, e, t))::l -> (match size t with
        | 8 -> (tds := Table.add nb (V (!name_proc, dec+8)) !tds ; 
                   let (ll, mm, s, u) = declaration (l, (dl, dec+8)) in 
                   (match (expr_conv (e, (dl, dec))) with 
                | (Pexpr (_, e, tpe), t) -> (Vseq (V_from_p (e), ll), mm, s, m t u)
                | _ -> failwith "declaration"))
        | 4 -> (match dl with
            | [] -> (tds := Table.add nb (V (!name_proc, dec+4)) !tds ; let ut = dec + 8 in 
                   let (ll, mm, s, u) = declaration (l, (ut::dl, dec+8)) in 
                   (match (expr_conv (e, (dl, dec))) with 
                | (Pexpr (_, e, tpe), t) -> (Vseq (V_from_p (e), ll), mm, s, m t u)
                | _ -> failwith "declaration"))
            | xdl::dl -> (tds := Table.add nb (V (!name_proc, xdl)) !tds ; 
                   let (ll, mm, s, u) = declaration (l, (dl, dec)) in 
                   (match (expr_conv (e, (dl, dec))) with 
                | (Pexpr (_, e, tpe), t) -> (Vseq (V_from_p (e), ll), mm, s, m t u)
                | _ -> failwith "declaration")))
        | _ -> failwith "quel imbecile je fait... ")


  | (ProcedureDecl ({proc_name = id ; proc_nb = nb ; proc_args = args ; proc_type = tpe ; proc_value = e}))::l -> 
      match e with
       | External (name) -> (tds := Table.add nb (EP (name)) !tds ; 
            declaration (l, (dl, dec)))
       | Declared (e) -> 
              (tds := Table.add nb (P (id^"__"^string_of_int (nb))) !tds ; 
               let utile = declaration (l, (dl, dec)) in 
               let exname = !name_proc in (name_proc := id^"__"^string_of_int (nb); 
               let extds = !tds in (declar_param 0 args; 
               let (a, (b, c)) = expr_conv (e, ([], 0)) in (tds := extds ;
               name_proc := exname ; list_proc := (a, c, id^"__"^string_of_int (nb), long args)::(!list_proc); 
               utile))));;





let second_transform e = (tds := Table.empty ; list_proc := [] ; 
       let (a, (b, c)) = expr_conv (e, ([], 0)) in (a, c, !name_proc, 0)::(!list_proc));;

