(*
$Id: syntax.mli,v 1.1.1.1 1998/06/23 22:35:09 monniaux Exp $
*)

type extent = (int*int)*(int*int);;

type iconst = int
and fconst = float
and identifier = string;;

(* Ce type n'est l que pour la dmonstration des possibilits
   d'tiquetage des lments syntaxique avec une zone du texte source. *)
type statement_d =
    For of identifier * expression * expression * (statement list)
  | While of expression * (statement list)
  | Expression of expression

and statement = statement_d * extent

and block = { declarations: declaration list;
              code: statement list }

and expression =
    Assignment of name * expression
  | Assignmentbis  of Typeintermed.expr * expression
  | Assignmentc    of Typeintermed.expr * expression
  | Assignmentcbis of Typeintermed.expr * expression

  | I of Typeintermed.expr

  | Minus of expression
  | Add of expression * expression
  | Mul of expression * expression
  | Sub of expression * expression
  | Div of expression * expression
  | FDiv of expression * expression
  | Mod of expression * expression

  | Not of expression
  | Or of expression * expression
  | And of expression * expression

  | Inferior of expression * expression
  | Superior of expression * expression
  | Equal of expression * expression

  | Identical of expression * expression

  | Name of name
  | IConst of iconst
  | FConst of fconst

  | Block of block

  | IfThen of expression * (statement list)
  | IfThenElse of expression * (statement list) * (statement list)  

  | ErrorExpr

and name =
    Identifier of identifier
(*  | Point of name * identifier *)
  | Brackets of name * (expression list)
  | Dereference of name
  | Call of name * (expression list)
  | Call_b of Typeintermed.expr * (expression list)

and procedure_call =
    { proc_name: name;
      proc_args: expression list }

and declaration =
    VariableDecl of identifier * type_spec
  | ArrayDecl of array_decl
  | IdentityDecl of identifier * expression * type_spec
  | IdentityDeclex of identifier * expression * type_spec
  | ProcedureDecl of procedure_decl
  | ErrorDecl

and proc_content = Declared of expression | External of identifier

and procedure_decl =
  { proc_name : identifier ;
    proc_args : (identifier * type_spec) list ;
    proc_type : result_type ;
    proc_value: proc_content }

and result_type =
    No_result_type
  | Result_type of type_spec

and type_spec =
    II of Typeintermed.result_type
  | NamedType of identifier
  | RefType of type_spec
  | RefArrayType of type_spec * int
  | ProcType of (type_spec list) * result_type
  | ErrorType

and array_decl =
  { array_id : identifier ;
    array_bounds : (expression * expression) list ;
    array_type : type_spec
  };;




