#include <stdio.h>
#include <signal.h>
#include <siginfo.h>
#include <ucontext.h>

void proc__main__(void);

void sigill_handler(int sig, siginfo_t *cause, ucontext_t *context)
{ unsigned int *codeptr;
  if (cause->si_code == ILL_ILLTRP)
    { codeptr = cause->si_addr;
      if (*codeptr == 0x91D02005) /* TA; masquer pour les autres conditions */
        fprintf(stderr, "LAX runtime error: range check\n");
    }
  abort();
}

void lax__bad_dimensions()
{
  fputs("lax runtime error: array dimensions don't match\n", stderr);
  abort();
}

void print_int(int x)
{
  printf("%d", x);
}

void print_real(double *x)
{
  printf("%f", *x);
}

void print_char(int x)
{
  putchar(x);
}

int input_int()
{
  int i;
  scanf("%d", &i);
  return i;
}

double input_real()
{
  double i;
  scanf("%f", &i);
  return i;
}

main()
{
  struct sigaction action;
  action.sa_sigaction = sigill_handler;
  sigemptyset(&action.sa_mask);
  action.sa_flags = SA_SIGINFO;

  sigaction(SIGILL, &action, NULL);
  proc__main__();
  return 0;
}
