(*
$Id: typeintermed2.mli,v 1.1.1.1 1998/06/23 22:35:10 monniaux Exp $
*)

type virtual_reg = int

and iexpr = virtual_reg * iexpr_in
and iexpr_in =
             IAdd of iexpr*iexpr
           | ISub of iexpr*iexpr
           | IDiv of iexpr*iexpr
           | IMod of iexpr*iexpr
           | IMul of iexpr*iexpr
           | INeg of iexpr
           | IConst of int
           | I_peek of pexpr
           | Iprocedure of pexpr * expr list
           | I_ITE of bexpr*iexpr*iexpr
           | Iseq of vexpr*iexpr
           | Iinvseq of iexpr * vexpr
           | I_reg

and fexpr = virtual_reg * fexpr_in
and fexpr_in =
             FAdd of fexpr*fexpr
           | FSub of fexpr*fexpr
           | FDiv of fexpr*fexpr
           | FMul of fexpr*fexpr
           | FNeg of fexpr
           | FConst of float
           | F_from_i of iexpr
           | F_peek of pexpr
           | Fprocedure of pexpr * (expr list)
           | F_ITE of bexpr*fexpr*fexpr
           | Fseq of vexpr*fexpr
           | Finvseq of fexpr * vexpr
           | F_reg

and pexpr = virtual_reg * pexpr_in
and pexpr_in =
             PAdd of pexpr*iexpr
           | P_peek of pexpr
           | Pprocedure of pexpr * (expr list)
           | P_ITE of bexpr*pexpr*pexpr
           | Pseq of vexpr*pexpr
           | IAssignment of pexpr * iexpr
           | FAssignment of pexpr * fexpr
           | BAssignment of pexpr * bexpr
           | PAssignment of pexpr * pexpr
           | Nil
           | FramePtr
           | Alloca of iexpr
           | AsmLabel of string
           | Pinvseq of pexpr * vexpr
           | P_reg

and bexpr = 
             B_peek of pexpr
           | Bprocedure of pexpr * (expr list)
           | IInf of iexpr*iexpr
           | ISup of iexpr*iexpr
           | FInf of fexpr*fexpr
           | FSup of fexpr*fexpr
           | IEgal of iexpr*iexpr
           | BEgal of bexpr*bexpr
           | FEgal of fexpr*fexpr
           | PEgal of pexpr*pexpr
           | True
           | False
           | BAnd of bexpr*bexpr
           | BOr of bexpr*bexpr
           | BNot of bexpr
           | B_ITE of bexpr * bexpr * bexpr
           | Bseq of vexpr * bexpr
           | Binvseq of bexpr * vexpr
           | B_reg of virtual_reg

and vexpr =  While of bexpr * vexpr
           | Vprocedure of pexpr * (expr list)
           | V_from_i of iexpr
           | V_from_f of fexpr
           | V_from_b of bexpr
           | V_from_p of pexpr
           | Vseq of vexpr * vexpr
           | V_IT of bexpr * vexpr
           | V_ITE of bexpr * vexpr * vexpr
           | CopyBlock of pexpr * pexpr * iexpr (* offset des 4 derniers octets *)
           | FCopyBlock of pexpr * pexpr * iexpr (* offset des 8 derniers octets *)
           | Free
           | NNop
           | Erreur     (* Le code genere doit provoquer une erreur : affectation de tableaux *)
                              (* ayant des dimentions differentes *)

and expr = Iexpr of iexpr
           | Fexpr of fexpr
           | Bexpr of bexpr
           | Vexpr of vexpr
           | Pexpr of pexpr
;;
